# -*- coding: utf-8 -*-
from dsa4_1 import Node

class Stack:
    def __init__(self):
        self.head = None

    def isEmpty(self):
        return self.head == None

    def push(self,item):
        temp = Node(item)
        temp.setNext(self.head)
        self.head = temp

    def pop(self):
        if self.isEmpty():
            raise IndexError('pop from empty stack')
        temp = self.head.getData()
        self.head = self.head.getNext()
        return temp

    def peek(self):
        if self.isEmpty():
            raise IndexError('peek from empty stack')
        return self.head.getData()

    def size(self):
        current = self.head
        count = 0
        while current != None:
            current = current.getNext()
            count = count +1
        return count

class Queue:
    def __init__(self):
        self.head = None

    def isEmpty(self):
        return self.head == None

    def enqueue(self,item):    #将item插到末尾
        current = self.head
        temp = Node(item)
        if current != None:
            while current.getNext() != None:
                current = current.getNext()
            current.setNext(temp)
        else:
            self.head = temp

    def dequeue(self):
        temp = self.head.getData()
        self.head = self.head.getNext()
        return temp

    def size(self):
        current = self.head
        count = 0
        while current != None:
            current = current.getNext()
            count = count +1
        return count




