# 陈一潇
# 1400017639


# from dsa4.dsa4_1 import Node, UnorderedList  # pycharm中的import，因为是从工程文件目录下开始导入，故而得加文件夹，这一行仅用于我编写代码时
from dsa4_1 import Node, UnorderedList


# 定义了 Stack 和 Queue，和原始的定义没有区别，使用上也没有区别。
class Stack:
    def __init__(self):
        self.items = UnorderedList()

    def isEmpty(self):
        return self.items.isEmpty()

    def push(self, item):
        self.items.add(item)

    def pop(self):
        return self.items.pop(0)

    def peek(self):
        return self.items[0]

    def size(self):
        return len(self.items)


class Queue:
    def __init__(self):
        self.items = UnorderedList()

    def isEmpty(self):
        return self.items.isEmpty()

    def enqueue(self, item):
        self.items.append(item)

    def dequeue(self):
        return self.items.pop(0)

    def size(self):
        return len(self.items)


if __name__ == '__main__':

    s = Stack()
    print(s.isEmpty())
    s.push(4)
    s.push('dog')
    print(s.peek())
    s.push(True)
    print(s.size())
    print(s.isEmpty())
    s.push(8.4)
    print(s.pop())
    print(s.pop())
    print(s.size())

    q = Queue()
    q.enqueue(4)
    q.enqueue('dog')
    q.enqueue(True)
    print(q.size())
    print(q.isEmpty())
    print(q.dequeue())
    print(q.dequeue())