class Node:
    def __init__(self,initdata):
        self.data = initdata
        self.next = None
    def getdata(self):
        return self.data
    def getnext(self):
        return self.next
    def setdata(self,newdata):
        self.data = newdata
    def setnext(self,newnext):
        self.next = newnext
class Unorderedlist:
    def __init__(self):
        self.head = None
    def __len__(self):
        current = self.head
        count = 0
        while current != None:
            current = current.getnext()
            count = count + 1
        return count
    def append(self,item):
        current = self.head
        temp = Node(item)
        if current == None:
            self.head = temp
        else:
            while current.getnext() != None:
                current = current.getnext()
            current.setnext(temp)
    def index(self,item):
        current = self.head
        count = 0
        found = False
        while not found and current != None:
            if current.getdata() == item:
                found = True
            else:
                current = current.getnext()
            count = count + 1
        if  not found:
            raise IndexError('not found')
        else:
            return count-1
    def pop1(self):
        current = self.head
        previous = None
        while current.getnext() != None:
            previous = current
            current = current.getnext()
        if previous == None:
            self.head = None
        else:
            previous.setnext(None)
        return current.getdata()
    def pop2(self,pos):
        current = self.head
        previous = None
        count = 0
        while count != pos:
            previous = current
            current = current.getnext()
            count = count + 1
        if previous == None:
            self.head = current.getnext()
        else:
            previous.setnext(current.getnext())
        return current.getdata()
    def insert(self,pos,item):
        if pos < -len(self) or pos > len(self):
            print('no this position')
        else:
            if pos < 0:
                pos = pos + len(self)
            temp = Node(item)
            current = self.head
            previous = None
            count = 0
            while count < pos:
                previous = current
                current = current.getnext()
                count = count + 1
            if previous == None:
                temp.setnext(current)
                self.head = temp
            else:
                temp.setnext(current)
                previous.setnext(temp)
    def __str__(self):
        current = self.head
        s = ''
        while current != None:
            s = s + str(current.getdata())
            current = current.getnext()
        return s
    def __getitem__(self,n):
        if isinstance(n,int):
            if n >= len(self) or n < -len(self):
                raise IndexError('out of range')
            elif n <0:
                n = n + len(self)
            current = self.head
            count = 0
            while count < n:
                current = current.getnext()
                count = count + 1
            return current.getdata()
        if isinstance(n,slice):
            start = n.start
            stop = n.stop
            if start >= len(self) or start < -len(self):
                raise IndexError('out of range')
            elif start <0:
                start = start + len(self)
            if stop >= len(self) or stop < -len(self):
                raise IndexError('out of range')
            elif stop <0:
                stop = stop + len(self)
            current = self.head
            count = 0
            while count < start:
                current = current.getnext()
                count = count + 1
            aList = list()                        
            while count < stop:
                aList.append(current.getdata())
                current = current.getnext()
                count = count + 1
            return aList
