class Node():
    def __init__(self, initdata):
        self.data = initdata
        self.next = None

    def getData(self):
        return self.data

    def getNext(self):
        return self.next

    def setData(self, newdata):
        self.data = newdata

    def setNext(self, newnext):
        self.next = newnext

    def prin(self):
        print(self.data)


class UnorderedList():
    def __init__(self):
        self.head = None
        self.tail = self.head

    def add(self, item):
        temp = Node(item)
        temp.setNext(self.head)
        if self.tail is None:
            self.tail = temp
        self.head = temp

    def append(self, item):
        temp = Node(item)
        if self.tail is None:
            self.head = temp
        else:
            self.tail.setNext(temp)
        self.tail = temp

    def printlist(self):
        temp = self.head
        while temp is not None:
            print(temp.data)
            temp = temp.getNext()

        