class Node:
    def __init__(self,initdata):
        self.data = initdata
        self.next = None
    def getdata(self):
        return self.data
    def getnext(self):
        return self.next
    def setdata(self,newdata):
        self.data = newdata
    def setnext(self,newnext):
        self.next = newnext
class Stack:
    def __init__(self):
        self.head = None
    def isEmpty(self):
        return self.head == None
    def push(self,item):
        temp = Node(item)
        temp.setnext(self.head)
        self.head = temp
    def pop(self):
        current = self.head
        self.head = current.getnext()
        return current.getdata()
    def peek(self):
        return self.head.getdata()
    def size(self):
        current = self.head
        count = 0
        while current != None:
            count = count + 1
            current = current.getnext()
        return count
class Queue:
    def __init__(self):
        self.head = None
        self.tail = None
    def enqueue(self,item):
        temp = Node(item)
        if self.tail == None:
            self.tail = temp
        else:
            self.tail.setnext(temp)
        self.tail = temp
        if self.head == None:
            self.head = temp            
    def dequeue(self):
        current = self.head
        self.head = current.getnext()
        return current.getdata()
    def size(self):
        current = self.head
        count = 0
        while current != None:
            count = count + 1
            current = current.getnext()
        return count
    def isEmpty(self):
        return self.head == None
