class Node:
    def __init__(self,initdata):
        self.data = initdata
        self.next = None
        self.prev = None
    def getdata(self):
        return self.data
    def getnext(self):
        return self.next
    def getprev(self):
        return self.prev
    def setdata(selfself,newdata):
        self.data = newdata
    def setnext(self,newnext):
        self.next = newnext
    def setprev(self,newprev):
        self.prev = newprev
class UnorderedList:
    def __init__(self):
        self.head = None
        self.tail = None
    def add(self,item):
        temp = Node(item)
        if self.head == None:
            self.head = temp
            self.tail = temp
        else:
            temp.setnext(self.head)
            self.head.prev = temp
            self.head = temp
    def remove(self,item):
        current = self.head
        previous = None
        found = False
        while not found:
            if current.getdata() == item:
                found = True
            else:
                previous = current
                current = current.getnext()
        if previous == None and current == self.tail:
            self.head = None
            self.tail = None
        else:
            if current == self.tail:
                self.tail = previous
            previous.setnext(current.getnext())
            if previous == None:
                self.head = current.getnext()
    def append(self,item):
        temp = Node(item)
        if self.head == None:
            self.head = temp
            self.tail = temp
        else:
            self.tail.setnext(temp)
            self.tail = temp
    def search(self,item):
        current = self.head
        found = False
        while current != None and not found:
            if current.getdata == item:
                found = True
            current = current.getnext()
        return found
    def insert(self,pos,item):
        if pos < -len(self) or pos > len(self):
            print('no this position')
        else:
            if pos < 0:
                pos = pos + len(self)
            temp = Node(item)
            current = self.head
            previous = None
            count = 0
            while count < pos:
                previous = current
                current = current.getnext()
                count = count + 1
            if previous == None:
                temp.setnext(current)
                self.head = temp
            else:
                temp.setnext(current)
                previous.setnext(temp)
            if pos == len(self)-1:
                tail = temp
    def pop(self):
        current = self.head
        previous = None
        while current.getnext() != None:
            previous = current
            current = current.getnext()
        if previous == None:
            self.head = None
        else:
            previous.setnext(None)
        tail = tail.getprev()
        return current.getdata()
                
